-- ~*~*~*~*~*~*分布加载和进度条功能*~*~*~*~*~*~*~*~
-- 分步loading
local batch_one_finish = false
local batch_two_finish = false

function init_batch_load_progress()

    -- 分步loading 完成
    scene.on_batch_load_finish = function(id,ret)
        onBatchLoadFinish(id,ret)
    end

    -- 分步loading
    scene.on_batch_load_progress_update = function(id, progress)
        onBatchLoadProgressUpdate(id,progress)
    end

    scene:load_batch(1)

end

function onBatchLoadFinish(id, ret)
    scene:load_batch(1)
    if (id == 1 and ret == -1) then
         BatchLoader.send_download_retry_msg()
         return
    end

    if (id == 1 and ret == 0) then
        batch_one_finish = true

        scene:delete_node_by_name("on_loading_text")
        scene:delete_node_by_name("on_loading_box")
        scene:delete_node_by_name("loading_bg")

        -- 删除百分比进度
        scene:delete_node_by_name("progressBar")
        scene:delete_node_by_name("progress_num_f")
        scene:delete_node_by_name("progress_num_x")
        scene:delete_node_by_name("progress_num_y")
        scene:delete_node_by_name("progress_num_z")

        scene.startButton:set_visible(true)
        scene.introduce:set_visible(true)
    end
end

function onBatchLoadProgressUpdate(id, progress)
    if (id == 1) then
    	AR:perform_after(10,updateprogress_1(progress))
    end
end

function updateprogress_1(progress)
    -- 更新进度条
    local pathProgress = "res/media/progressBar/bar"..tostring(progress)..".png"
    scene.progressBar:replace_texture(pathProgress, "uDiffuseTexture")

end

BatchLoader.user_confirm_download = function(batch_id)
    if (batch_id == 'batch1') then
    	scene:load_batch(1)
    end
end

function simulateLoadProgressUpdate(time,done)

    if done == true then
        AR:perform_after(time,updateprogress_1(100))
        return 1
    end

    if time % 2 == 0 then 
        local progress = time / 2
        if progress >= 100 then
            return 1
        end
        updateprogress_1(progress)
    end
    return 0 
end