function LOAD_FSM()
	SEPARATOR = '.'
	ANY       = '*'
	ANYSTATE  = ANY .. SEPARATOR
	ANYEVENT  = SEPARATOR .. ANY
	UNKNOWN   = ANYSTATE .. ANY

	FSM = {
		__call = function (self)
			local fsm = {
				_state = "unknown",
				_state_table = {},			
				_str = "",			
				_silence = false,

				init = function(self, t) 
					self._state = t[1][1]
					for i,v in ipairs(t) do
						local old_state, new_state, action = v[1],v[2],v[3]
						self._state_table[old_state..SEPARATOR..new_state] = action
					end
				end,
			}

			fsm.set_status = function(self,state)
				self:update_status(state)
				self._state = state
			end
			
			fsm.update_status = function(self,state)
				local old_state = self._state
				local state_key = old_state..SEPARATOR..state
				local action = self._state_table[state_key]
				if action ~= nil then
					return action()
				end
			end
			
			fsm.current_status = function(self)
				return self._state
			end

			return fsm
		end,
	}
	setmetatable(FSM,FSM)

	-- return FSM
end

LOAD_FSM()

-- function action1()
-- 	print("action1")
-- end
-- function action2()
-- 	print("action2")
-- end

-- local ta = {
-- 	{"state1", "state2", action1},
-- 	{"state2", "state3", action2}
-- }
-- t = FSM()
-- t:init(ta)
-- t:set_status("state2")
