-- ~*~*~*~*~*~*粒子系统发射器*~*~*~*~*~*~*~*~
-- 进行一次爆炸, pos爆炸位置,ARVec3类型
function create_single_explosion(pos)
    scene.single_explosion_fire:set_property_bool("visible", true)
    scene.single_explosion_fire:set_property_bool("particle/emit_status", true)
    scene.single_explosion_fire:set_property_vec3("particle/emitter_position", pos)
    scene.single_explosion_fire:set_property_int("particle/emit_particle", 1)

    scene.single_explosion_smoke:set_property_bool("visible", true)
    scene.single_explosion_smoke:set_property_bool("particle/emit_status", true)
    scene.single_explosion_smoke:set_property_vec3("particle/emitter_position", pos)
    scene.single_explosion_smoke:set_property_int("particle/emit_particle", 5)
end


-- 进行多次连续爆炸, center爆炸位置,ARVec3类型, extent 爆炸box范围, n爆炸次数, delta_time 爆炸间隔次数
function create_multi_explosion(center, extent, n, delta_time)
    math.randomseed(os.time())
    local var_1 = math.random(-100,100) / 100
    local var_2 = math.random(-100,100) / 100
    local var_3 = math.random(-100,100) / 100
    local pos = center + extent * ae.ARVec3:new_local(var_1, var_2, var_3)
    create_single_explosion(pos)

    for var = 1, n-1, 1 do
        AR:perform_after(delta_time * var, function()
            local var_1 = math.random(-100,100) / 100
            local var_2 = math.random(-100,100) / 100
            local var_3 = math.random(-100,100) / 100
            local pos = center + extent * ae.ARVec3:new_local(var_1, var_2, var_3)
            create_single_explosion(pos)
        end)
    end  
end

-- 发射一次怪物被子弹击中的效果
function create_monster_hit_bleeding(pos)
    scene.monster_hit_bleed:set_property_bool("visible", true)
    scene.monster_hit_bleed:set_property_bool("particle/emit_status", true)
    scene.monster_hit_bleed:set_property_vec3("particle/emitter_position", pos)
    scene.monster_hit_bleed:set_property_int("particle/emit_particle", 1)
end

-- 子弹特效
function create_bullet_fire(pos)
    scene.fire_particle:set_property_bool("visible", true)
    scene.fire_particle:set_property_bool("particle/emit_status", true)
    scene.fire_particle:set_property_vec3("particle/emitter_position", pos)
    scene.fire_particle:set_property_int("particle/emit_particle", 5)
end
