
function create_player()
	player = {
    life = 100,
    score = 0,
    missile_count = 1,
    missile_create_time = 5000,
    const_missile_time = 5000,
    is_creating_missile = false,

    update = function(self, delta)
        self:produce_missile(delta)
    end,

    produce_missile = function(self, delta)

        if (self.missile_count == 0 and self.is_creating_missile == false) then
            self.is_creating_missile = true
            self.missile_create_time = self.const_missile_time
        elseif (self.missile_count > 0) then
            --donothing
            self.is_creating_missile = false
            self.missile_create_time = self.const_missile_time

        elseif(self.is_creating_missile == true) then

            self.missile_create_time = self.missile_create_time - delta
            local t1,t2 = math.modf(self.missile_create_time / 1000)
            local num = t1 + 1
            if (num < 0) then
                num = 0
            end
            scene.shoot_left:replace_texture("res/texture/missile_time_update/"..tostring(num)..".png","uDiffuseTexture")

            if (self.missile_create_time <= 0) then
                self:add_missile(1)
            end
        end

    end,

    launch_missile = function(self)
        if (self.missile_count > 0) then
            launch_missile(3000)
            self.missile_count = self.missile_count - 1
            score_board:update_js("changeMissileCount('"..self.missile_count.."')")
        end
    end,

    add_missile = function(self, count)


        self.missile_count = self.missile_count + count
        scene.shoot_left:replace_texture("res/texture/missile_time_update/0.png", "uDiffuseTexture")
        score_board:update_js("changeMissileCount('"..self.missile_count.."')")

        --播放获取弹药的音效
        local config = {}
        config["repeat_count"] = 1
        config["is_remote"] = 0
        local media_session = scene.shoot_left:get_media_controller():create_media_session("audio", "res/media/get_missile.mp3", config)
        media_session:play()

        ARLOG("add_missile "..tostring(self.missile_count))
    end,

    receive_damage = function(self, damage)
        self.life = self.life - damage

        if (self.life <= 0) then
            self.life = 0
        end
        score_board:update_js("changeHpHeartCount('"..self.life.."')")
        if (self.life == 0) then
            -- 游戏结束逻辑
            ARLOG("game over with score = "..self.score)
            game_over_execute(self.score)
        end
    

        scene.hitted:set_property_bool("visible",true)
        AR:perform_after(1000, function()
            scene.hitted:set_property_bool("visible",false)
        end)

        local config = {}
        config["repeat_count"] = 1
        config["is_remote"] = 0
        local media_session = scene.player:get_media_controller():create_media_session("audio", "res/media/player/player_hurt.mp3", config)
        media_session:play()
    end,

    receive_scroe = function(self, score)
        self.score = self.score + score
        score_board:update_js("changeScore('"..self.score.."')")
        ARLOG("receive score = "..self.score)
    end,

    is_hitted = function(self, pos)
        local bullet_pos = pos
        local camera_pos = scene:get_active_camera():get_property_vec3("world_position")
        local distance = bullet_pos - camera_pos

        if (distance:length() < 0.05) then
            return true
        else 
        	return false
        end
    end,

    world_position = function(self)
        local camera_pos = scene:get_active_camera():get_property_vec3("world_position")
        return camera_pos
    end
    }
end


create_player()

function player_update(delta)
    player:update(delta)
end

function player_reset()
    create_player()
end
