
-- 记录当前touch
cur_touch = {}
-- 记录当前touch时间
delta_time = 0

local multi_fire_gun_media_session = nil
local is_play_multi_fire = false

function init_touch_controller()
     -- 增加手势控制器
    local input_controller = scene:get_input_controller()
    local touch_controller = input_controller:get_touch_controller()
    touch_controller:set_update_handler(on_touch_update)
end

-- 响应touch事件
function on_touch_update(touch)
    cur_touch.x = touch.x 
    cur_touch.y = touch.y
    cur_touch.id = touch.touch_id 
    cur_touch.phase = touch.phase
    if touch.phase == "touch_begin" then        
        delta_time = 0
    end
end

function init_shot_controller()

     -- 添加射击控制器对象
    --button_left = controller:new(nil,ButtonType.shoot)
    --button_right = controller:new(nil,ButtonType.boom)

    scene.shoot_left:set_interaction_event_handler("button_state_changed",button_left_click)

    scene.shoot_right:set_interaction_event_handler("button_state_changed",button_right_click)
    
end

-- button_right_click
function button_left_click( state )
    if (state == "active") then
        player:launch_missile()
    end
end

-- button_left_click
function button_right_click( state )
    if (state == "active") then
        controller:bullet_produce()
        play_fire_gun_music()
    end
end


-- collision
function bullet_damage_check( delta )
    controller:bullet_update(delta)

    for i,v in ipairs(monster_list) do

        if (v.is_alive) then
            local dragon = v.eg_node
            local is_collision, collision_pos = controller:check_collision(dragon, delta)
            if (is_collision) then
                create_monster_hit_bleeding(collision_pos)
                v:receive_damage(100)
            end
        end
    end
    controller:bullet_clear()
end

-- long_press_shot
function long_press_shot( delta )

    if (cur_touch.x == nil or cur_touch.y == nil) then
        return
    end


    if cur_touch.phase == "touch_end" then

        if (multi_fire_gun_media_session ~= nil) then
            multi_fire_gun_media_session:stop()
            is_play_multi_fire = false
        end
        return
    end

    delta_time = delta_time + delta
    if delta_time < 300 then
        return
    end
    delta_time = delta_time - 200

    local x_size = cur_touch.x / screen_size.x
    local y_size = cur_touch.y / screen_size.y

    if (x_size > 0.15 and x_size < 0.5) and (y_size > 0.68 and y_size < 0.9) then
        controller:bullet_produce()

        if (is_play_multi_fire == false) then
            local config = {}
            config["repeat_count"] = -1
            config["is_remote"] = 0
            config["forward_conflict_solving_strategy"] = "cancel_all_forward"
            multi_fire_gun_media_session = scene.shoot_right:get_media_controller():create_media_session("audio", "res/media/weapon/multi_gun_fire.mp3", config)
            multi_fire_gun_media_session:play()

            is_play_multi_fire = true
        end
    end
end


function bullet_shot_and_damage_check(delta)
    long_press_shot(delta)
    bullet_damage_check(delta)
end




