-- ~*~*~*~*~*~*~非业务工具类代码*~*~*~*~*~*~*~*~
-- 将table 中 的node删除 并初始化table

function clear_dic(dic)
    for k,v in pairs(dic) do 
        local name = v:get_property_string("name")
        ARLOG(name)
        scene:remove_node_by_name(name)
    end
    return {}
end

-- 得到table中的元素个数
function get_table_count(table)
    local count = 0
    for k,v in pairs(table) do
        count = count + 1
    end
    return count
end

-- 删除table中指定key的对象
function remove_table_by_key(table, key)
    new_table = {}
    local count = 0
    for k,v in pairs(table) do
        if k ~= key then new_table[k]=v end
    end

    -- todo 被删除的元素需要从root中删除

    return new_table
end

-- 宽高是否改变
function is_extent_change(extent1, extent2)

    if extent1.x == extent2.x and extent1.y == extent2.y and  extent1.z == extent2.z then
        return false
    else
        return true
    end

end

-- 是否在发射区域
function is_in_shoot_area(x, y)

    if (x>500 and x<700) and (y>1300 and y<1700) then
        return true
    else
        return false
    end
end

--生成一个可以朝向固定朝向的ARQuat
--dir:front的向量

function billboard(dir)
    local front = dir:normalize()

    local up = ae.ARVec3:new_local(0,1,0)

    local left = up:cross(front)
    left = left:normalize()

    up = front:cross(left)
    up = up:normalize()

    front = ae.ARVec4:new_local(front.x, front.y, front.z, 0)
    left = ae.ARVec4:new_local(left.x, left.y, left.z, 0)
    up = ae.ARVec4:new_local(up.x, up.y, up.z, 0)

    -- 计算武器的位置
    local pos = ae.ARVec4:new_local(0,0,0,1)

    local mat44 = ae.ARMat44:new_local(left, up, front, pos)

    --ARLOG("mat44 "..gun_mat44:to_string())

    local pos = ae.ARVec3:new_local()
    local quat = ae.ARQuat:new_local()
    local scale = ae.ARVec3:new_local()

    mat44:decompose_matrix(pos, quat, scale)

    return quat

end

function point_distance(p1, p2) 
    return math.sqrt((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y) + (p1.z - p2.z)*(p1.z - p2.z))
end

function reset_game()
    if (radar ~= nil) then
        ARLOG("reset radar")
        radar:reset()
    end

    if (plane_controller ~= nil) then
        ARLOG("plane_controller reset")
        plane_controller:reset()
    end

    missile_list_reset()
    portal_list_reset()
    monster_list_reset()
    monster_weapon_list_reset()
    player_reset()

    controller:bullet_all_clear()

    ARLOG("reset game success")
end
